/**
 * Open Command Prompt Shell Extension
 * Copyright (C) 2007 Kai Liu.  All rights reserved.
 *
 * Please refer to readme.txt for information about this source code.
 * Please refer to license.txt for details about distribution and modification.
 **/

#ifndef __CCMDOPEN_HPP__
#define __CCMDOPEN_HPP__

#include "globals.h"
#include <string>
#include <list>
typedef std::list< std::basic_string<TCHAR> > LSTTSTR;
typedef LSTTSTR::const_iterator ITR_LSTTSTR;

class CCmdOpen : public IShellExtInit, IContextMenu
{
	protected:
		ULONG m_cRef;
		LSTTSTR m_lsszPaths;

	public:
		CCmdOpen( ) { ++g_cRefThisDll; m_cRef = 1; }
		~CCmdOpen( ) { --g_cRefThisDll; }

		// IUnknown members
		STDMETHODIMP QueryInterface( REFIID, LPVOID * );
		STDMETHODIMP_(ULONG) AddRef( ) { return(++m_cRef); }
		STDMETHODIMP_(ULONG) Release( ) { if (--m_cRef == 0) delete this; return(m_cRef); }

		// IShellExtInit members
		STDMETHODIMP Initialize( LPCITEMIDLIST, LPDATAOBJECT, HKEY );

		// IContextMenu members
		STDMETHODIMP QueryContextMenu( HMENU, UINT, UINT, UINT, UINT );
		STDMETHODIMP InvokeCommand( LPCMINVOKECOMMANDINFO );
		STDMETHODIMP GetCommandString( UINT_PTR, UINT, UINT *, LPSTR, UINT );
};

typedef CCmdOpen *LPCCMDOPEN;

#endif
