/**
 * Open Command Prompt Shell Extension
 * Copyright (C) 2007 Kai Liu.  All rights reserved.
 *
 * Please refer to readme.txt for information about this source code.
 * Please refer to license.txt for details about distribution and modification.
 **/

#include "CCmdOpenClassFactory.hpp"
#include "CCmdOpen.hpp"

STDMETHODIMP CCmdOpenClassFactory::QueryInterface( REFIID riid, LPVOID *ppv )
{
	*ppv = NULL;

	if (IsEqualIID(riid, IID_IUnknown))
	{
		*ppv = this;
	}
	else if (IsEqualIID(riid, IID_IClassFactory))
	{
		*ppv = (LPCLASSFACTORY)this;
	}

	if (*ppv)
	{
		AddRef();
		return(S_OK);
	}
	else return(E_NOINTERFACE);
}

STDMETHODIMP CCmdOpenClassFactory::CreateInstance( LPUNKNOWN pUnkOuter, REFIID riid, LPVOID *ppv )
{
	*ppv = NULL;

	if (pUnkOuter) return(CLASS_E_NOAGGREGATION);

	LPCCMDOPEN lpCmdOpen = new CCmdOpen;
	if (lpCmdOpen == NULL) return(E_OUTOFMEMORY);

	HRESULT hr = lpCmdOpen->QueryInterface(riid, ppv);
	lpCmdOpen->Release();
	return(hr);
}
