/**
 * Open Command Prompt Shell Extension
 * Copyright (C) 2007 Kai Liu.  All rights reserved.
 *
 * Please refer to readme.txt for information about this source code.
 * Please refer to license.txt for details about distribution and modification.
 **/

#ifndef __CCMDOPENCLASSFACTORY_HPP__
#define __CCMDOPENCLASSFACTORY_HPP__

#include "globals.h"

class CCmdOpenClassFactory : public IClassFactory
{
	protected:
		ULONG m_cRef;

	public:
		CCmdOpenClassFactory( ) { ++g_cRefThisDll; m_cRef = 1; }
		~CCmdOpenClassFactory( ) { --g_cRefThisDll; }

		// IUnknown members
		STDMETHODIMP QueryInterface( REFIID, LPVOID * );
		STDMETHODIMP_(ULONG) AddRef( ) { return(++m_cRef); }
		STDMETHODIMP_(ULONG) Release( ) { if (--m_cRef == 0) delete this; return(m_cRef); }

		// IClassFactory members
		STDMETHODIMP CreateInstance( LPUNKNOWN, REFIID, LPVOID * );
		STDMETHODIMP LockServer( BOOL ) { return(E_NOTIMPL); }
};

typedef CCmdOpenClassFactory *LPCCMDOPENCLASSFACTORY;

#endif
