/**
 * Open Command Prompt Shell Extension
 * Copyright (C) 2007 Kai Liu.  All rights reserved.
 *
 * Please refer to readme.txt for information about this source code.
 * Please refer to license.txt for details about distribution and modification.
 **/

#include "RegHelpers.h"

HKEY RegOpen( HKEY hKey, LPCTSTR lpSubKey, LPCTSTR lpSubst )
{
	HKEY hKeyRet = NULL;
	TCHAR szJoinedKey[0x100] = { 0 };
	if (lpSubst) wnsprintf(szJoinedKey, 0x100, lpSubKey, lpSubst);

	if (RegCreateKeyEx(hKey, (lpSubst) ? szJoinedKey : lpSubKey, 0, TEXT(""), REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hKeyRet, NULL) == ERROR_SUCCESS)
		return(hKeyRet);
	else
		return(NULL);
}

BOOL RegDelete( HKEY hKey, LPCTSTR lpSubKey, LPCTSTR lpSubst )
{
	LONG lResult;
	TCHAR szJoinedKey[0x100] = { 0 };
	if (lpSubst) wnsprintf(szJoinedKey, 0x100, lpSubKey, lpSubst);

	lResult = SHDeleteKey(hKey, (lpSubst) ? szJoinedKey : lpSubKey);
	return(lResult == ERROR_SUCCESS || lResult == ERROR_FILE_NOT_FOUND);
}

BOOL RegSetSZ( HKEY hKey, LPCTSTR lpValueName, LPCTSTR lpData )
{
	return(RegSetValueEx(hKey, lpValueName, 0, REG_SZ, (LPBYTE)lpData, (lstrlen(lpData) + 1) * sizeof(lpData[0])) == ERROR_SUCCESS);
}

BOOL RegSetDW( HKEY hKey, LPCTSTR lpValueName, DWORD dwData )
{
	return(RegSetValueEx(hKey, lpValueName, 0, REG_DWORD, (LPBYTE)&dwData, sizeof(dwData)) == ERROR_SUCCESS);
}
