/**
 * Open Command Prompt Shell Extension
 * Copyright (C) 2007 Kai Liu.  All rights reserved.
 *
 * Please refer to readme.txt for information about this source code.
 * Please refer to license.txt for details about distribution and modification.
 **/

#ifndef __GLOBALS_H__
#define __GLOBALS_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <windows.h>
#include <olectl.h>
#include <shlobj.h>

#include "CmdOpenTranslations.h"
#include "version.h"

// Define globals for bookkeeping this DLL instance
extern UINT g_cRefThisDll;
extern HMODULE g_hModThisDll;

// Define the data and strings used for COM registration
static const GUID CLSID_CmdOpen = { 0x693b08da, 0xda1f, 0x4f2b, { 0xa1, 0x45, 0xc0, 0x6b, 0xdf, 0x01, 0x86, 0x8a } };
#define CLSID_STR_CmdOpen TEXT("{693B08DA-DA1F-4f2b-A145-C06BDF01868A}")
#define CLSNAME_STR_CmdOpen TEXT("CmdOpen Shell Extension")
#define CLSTYPE_STR_CmdOpenBG TEXT("CmdOpenBG")
#define CLSTYPE_STR_CmdOpenFolder TEXT("CmdOpenFolder")
#define CLSTYPE_STR_CmdOpenMyDocs TEXT("CmdOpenMyDocs")

// Define helper macros
#define countof(x) (sizeof(x)/sizeof(x[0]))

#ifdef __cplusplus
}
#endif

#endif
